#!/usr/bin/perl

use strict;
use Calendar::Simple;
use lib qw(.);
use holiday;

print "Content-type: text/html; charset=UTF-8\n\n";

# Preference Parameter
my $nkfcmd=holiday::nkfcmd;
my $infile=holiday::infile;
my $tmpfile=holiday::tmpfile;
my $outfile=holiday::orgfile;
my $diridx=holiday::diridx;
my $inptscr=holiday::inptscr;
my $calcscr=holiday::calcscr;

# Variable Parameter
my ($dirpath, $pathinf, $scrname, $name, $value);
my (@qstr, %date);
if(defined $ENV{'PATH_TRANSLATED'}){
	$dirpath=$ENV{'PATH_TRANSLATED'};
	$dirpath=~s/$diridx.*//i;
	$dirpath=~s/\/$//;
}
if(defined $ENV{'PATH_INFO'}){
	$pathinf=$ENV{'PATH_INFO'};
	$pathinf=~s/\/$//;
}
if(defined $ENV{'SCRIPT_NAME'}){
	$scrname=$ENV{'SCRIPT_NAME'};
	$scrname=~s/$calcscr/$inptscr/;
	$scrname.=$pathinf;
}
if($ENV{'QUERY_STRING'} ne ""){
	@qstr=split('&', $ENV{'QUERY_STRING'});
	foreach my $iq (@qstr){
		($name, $value)=split('=', $iq);
		$date{$name}=$value;
	}
}
$date{'from'}=1 if($date{'from'} eq "");
$date{'from'}--;
if($date{'from'}<0){
	holiday::headprt($date{'align'});
	print "<H2>計算期間が不正です</H2>\n";
	print "<H2><FONT COLOR=#FF0000>正しい月数を入力し直して下さい</FONT></H2>\n";
	print "</DIV>\n" if(defined $date{'align'});
	print "<P>\n";
	holiday::returnprt($scrname, $date{'align'});
	print "</BODY>\n</HTML>\n";
	exit 1;
}

# Holiday Parameter Calculation
my $fromy=$date{'year'};
my $fromon=$date{'month'};
my $toy=$fromy;
my $tomon=$fromon+$date{'from'};
while($tomon>12){
	$toy++;
	$tomon-=12;
}
my $csm=$fromon;
my $cem=$tomon;
my $cnt=0;
my $iw=0;
my $ih=0;
my ($dmyw, $dmyh, %dmyp, %param);
while($fromy!=$toy){
	$cnt++;
	if($cnt!=1){
		$iw=$dmyw;
		$ih=$dmyh;
		$csm=1;
	}
	$cem=12;
	($dmyw, $dmyh, %dmyp)=holiday::dayparam($fromy, $csm, $cem, $iw, $ih);
	foreach my $id (sort(keys(%dmyp))){
		$param{$id}=$dmyp{$id};
	}
	$fromy++;
}
if($cnt!=0){
	$iw=$dmyw;
	$ih=$dmyh;
	$csm=1;
	$cem=$tomon;
}
($dmyw, $dmyh, %dmyp)=holiday::dayparam($toy, $csm, $cem, $iw, $ih);
foreach my $id (sort(keys(%dmyp))){
	$param{$id}=$dmyp{$id};
}

# Read File
my ($lnum, $cnum, $maxcol, $datkey);
my (@dnum, @row, @col, %cell);
if( -f "$dirpath/$infile"){
	open READ, "$nkfcmd -s -Lu $dirpath/$infile |" or die;
	while(my $line=<READ>){
		chomp($line);
		$lnum=$.;
		$lnum--;
		$row[$lnum]=$line;
	}
	close READ;
}
else{
		holiday::headprt($date{'align'});
		print "<H2>順位ファイルがありません</TH></TR>\n";
		print "<H2><FONT COLOR=#FF0000>順位ファイルをアップロードして下さい</FONT></H2>\n";
		print "</DIV>\n" if(defined $date{'align'});
		print "<P>\n";
		holiday::returnprt($scrname, $date{'align'});
		print "</BODY>\n</HTML>\n";
		exit 1;
}
my $maxrow=$lnum;
for($lnum=0; $lnum<=$maxrow; $lnum++){
	@col=split(',', $row[$lnum]);
	$cnum=0;
	foreach my $ix (@col){
		$cnum--;
		$datkey=$lnum.$cnum;
		$cell{$datkey}=$ix;
		$maxcol=abs($cnum) if($lnum==0);
	}
}

# Sort Parameter Calculation
my ($ckey, $pkey, %spara);
$dnum[0]=$maxrow;
for($cnum=1; $cnum<=$maxcol; $cnum++){
	$dnum[$cnum]=0;
	for($lnum=1; $lnum<=$maxrow; $lnum++){
		$datkey=$lnum."-".$cnum;
		$dnum[$cnum]++ if($cell{$datkey} ne "");
	}
	if($dnum[$cnum]>0){
		foreach my $ix (sort(keys(%param))){
			$pkey=$ix."=".$cnum;
			if($param{$ix}<0){
				$spara{$pkey}=-(abs($param{$ix})%$dnum[$cnum]);
				$spara{$pkey}=-$dnum[$cnum] if($spara{$pkey}==0);
			}
			else{
				$spara{$pkey}=$param{$ix}%$dnum[$cnum];
				$spara{$pkey}=$dnum[$cnum] if($spara{$pkey}==0);
			}
		}
	}
}

# Sort File Output
#open CSV, "> $dirpath/$tmpfile" or die;
open CSV, "> $dirpath/$outfile" or die;
flock CSV, 2;
print CSV "日付,$row[0]\n";
foreach my $iz (sort(keys(%param))){
	for($cnum=1; $cnum<=$maxcol; $cnum++){
		print CSV "$iz," if($cnum==1);
		$ckey=-$cnum;
		$pkey=$iz."=".$cnum;
		if($cnum%2==0){ $datkey=-$spara{$pkey}.$ckey; }
		else { $datkey=$spara{$pkey}.$ckey; }
		print CSV "$cell{$datkey}";
		print CSV "," if($cnum!=$maxcol);
		print CSV "\r\n" if($cnum==$maxcol);
	}
}
flock CSV, 8;
close CSV;

=comment
# CSV File Output
my ($prtyear, $prtmonth, $prtday, $holiday);
open SAVE, "|$nkfcmd -s -Lw > $dirpath/$outfile" or die;
open CSV, "$dirpath/$tmpfile" or die;
while(my $line=<CSV>){
	chomp($line);
	@col=split(',', $line);
	for($cnum=0; $cnum<=$maxcol; $cnum++){
		if($.==1){
			print SAVE "$col[$cnum]," if($cnum==0);
			if($cnum%2==1){
				$col[$cnum]=~s/平日//;
				print SAVE "$col[$cnum]";
				print SAVE "," if($cnum!=$maxcol-1);
				print SAVE "\n" if($cnum==$maxcol-1);
			}
		}
		else{
			if($cnum==0){
				print SAVE "$col[$cnum],";
				($prtyear, $prtmonth, $prtday)=split('-', $col[$cnum]);
				$holiday=holiday::whatday($prtyear, $prtmonth, $prtday);
			}
			else{
				if($holiday==0){
					if($cnum%2==1){
						print SAVE "$col[$cnum]";
						print SAVE "," if($cnum!=$maxcol-1);
					}
				}
				else{
					if($cnum%2==0){
						print SAVE "$col[$cnum]";
						print SAVE "," if($cnum!=$maxcol);
					}
				}
			}
			print SAVE "\n" if($cnum==$maxcol);
		}
	}
}
close CSV;
close SAVE;
=cut

# Standard Output
holiday::headprt($date{'align'});
print "<H2>計算は正常に終了しました</H2>\n";
print "<H2><FONT COLOR=#FF0000>表示順を変更した場合は必ず再計算して下さい</FONT></H2>\n";
print "<A HREF=\"$pathinf/$outfile\">計算ファイルのダウンロード</A>\n";
print "</DIV>\n" if(defined $date{'align'});
print "<P>\n";
holiday::returnprt($scrname, $date{'align'});
print "<P>\n";
print "<DIV ALIGN=$date{'align'}>\n" if(defined $date{'align'});
print "<A HREF=\"$pathinf/$infile\">順位ファイルのダウンロード</A>\n";
print "</DIV>\n" if(defined $date{'align'});
print "</BODY>\n</HTML>\n";
exit 0;

