#!/usr/bin/perl

use strict;
use lib qw(.);
use holiday;

print "Content-type: text/html; charset=UTF-8\n\n";

# Preference Parameter
my $nkfcmd=holiday::nkfcmd;
my $infile=holiday::infile;
my $diridx=holiday::diridx;
my $inptscr=holiday::inptscr;
my $subscr=holiday::subscr;
my $calcscr=holiday::calcscr;
my $viewscr=holiday::viewscr;

# Variable Parameter
my ($dirpath, $pathinf, $scrname, $name, $value);
my (@qstr, %date);
if(defined $ENV{'PATH_TRANSLATED'}){
	$dirpath=$ENV{'PATH_TRANSLATED'};
	$dirpath=~s/$diridx.*//i;
	$dirpath=~s/\/$//;
}
if(defined $ENV{'PATH_INFO'}){
	$pathinf=$ENV{'PATH_INFO'};
	$pathinf=~s/\/$//;
}
if(defined $ENV{'SCRIPT_NAME'}){
	$scrname=$ENV{'SCRIPT_NAME'};
	$scrname=~s/$inptscr/$subscr/;
	$scrname.=$pathinf;
}
if($ENV{'QUERY_STRING'} ne ""){
	@qstr=split('&', $ENV{'QUERY_STRING'});
	foreach my $iq (@qstr){
		($name, $value)=split('=', $iq);
		$date{$name}=$value;
	}
}
$date{'align'}="center" if($date{'align'} eq "");

# Read File
my ($lnum, $cnum, $maxcol, $datkey);
my (@row, @col, %cell);
if( -f "$dirpath/$infile"){
	open READ, "$nkfcmd -s -Lu $dirpath/$infile |" or die;
	while(my $line=<READ>){
		chomp($line);
		$lnum=$.;
		$lnum--;
		$row[$lnum]=$line;
	}
	close READ;
}
else{
	print "<HTML>\n<HEAD>\n";
	print "<TITLE>Duty Chart Input Page</TITLE>\n";
	print "</HEAD>\n\n<BODY>\n";
	print "<DIV ALIGN=$date{'align'}>\n";
	print "<H2>順位ファイルがありません</TH></TR>\n";
	print "<H2><FONT COLOR=#FF0000>順位ファイルをアップロードして下さい</FONT></H2>\n";
	print "</DIV>\n" if(defined $date{'align'});
	print "<P>\n";
	print "</BODY>\n</HTML>\n";
	exit 1;
}
my $maxrow=$lnum;
for($lnum=0; $lnum<=$maxrow; $lnum++){
	@col=split(',', $row[$lnum]);
	$cnum=0;
	foreach my $ix (@col){
		$cnum--;
		$datkey=$lnum.$cnum;
		$cell{$datkey}=$ix;
		$maxcol=abs($cnum) if($lnum==0);
	}
}

# Standard Output
print "<HTML>\n<HEAD>\n";
print "<TITLE>Duty Chart Input Page</TITLE>\n";
print "</HEAD>\n\n<BODY>\n";
print "<DIV ALIGN=$date{'align'}>\n";
print "<H3>①当番表順位入力フォーム</H3>\n";
print "<FORM METHOD=\"POST\" ACTION=\"$scrname\">\n";
print "<INPUT type=\"hidden\" value=\"$date{'align'}\" name=\"align\">\n" if(defined $date{'align'});
print "<TABLE BORDER=3 CELLPADDING=1 CELLSPACING=1>\n";
print "<TR><TH>順番</TH>";
if($maxrow==0){
	for($lnum=0; $lnum<=20; $lnum++){
		for($cnum=1; $cnum<=$maxcol; $cnum++){
			print "<TR><TH>$lnum</TH>" if($cnum==1 && $lnum!=0);
			$datkey=$lnum."-".$cnum;
			if($lnum==0){ print "<TD><INPUT type=\"text\" value=\"$cell{$datkey}\" name=\"$datkey\" size=\"20\"></TD>"; }
			else{ print "<TD><INPUT type=\"text\" name=\"$datkey\" size=\"20\"></TD>"; }
			print "</TR>\n" if($cnum==$maxcol);
		}
	}
}
else{
	for($lnum=0; $lnum<=$maxrow; $lnum++){
		for($cnum=1; $cnum<=$maxcol; $cnum++){
			print "<TR><TH>$lnum</TH>" if($cnum==1 && $lnum!=0);
			$datkey=$lnum."-".$cnum;
			print "<TD><INPUT type=\"text\" value=\"$cell{$datkey}\" name=\"$datkey\" size=\"20\"></TD>";
			print "</TR>\n" if($cnum==$maxcol);
		}
	}
	for($lnum=$maxrow+1; $lnum<=$maxrow*2; $lnum++){
		for($cnum=1; $cnum<=$maxcol; $cnum++){
			print "<TR><TH>$lnum</TH>" if($cnum==1);
			$datkey=$lnum."-".$cnum;
			print "<TD><INPUT type=\"text\" name=\"$datkey\" size=\"20\"></TD>";
			print "</TR>\n" if($cnum==$maxcol);
		}
	}
}
print "</TABLE>\n";
print "<P>\n";
print "<INPUT type=\"submit\" value=\"更新\">\n";
print "</FORM>\n";
print "</DIV>\n";
print "<HR>\n";
$ENV{'TZ'}="JST-9";
my $year=Date::Simple->new()->format('%Y');
my $month=Date::Simple->new()->format('%m')+1;
if($month==13){
	$year++;
	$month-=12;
}
$scrname=~s/$subscr/$calcscr/;
print "<DIV ALIGN=$date{'align'}>\n";
print "<TABLE>\n<TR>\n<TH>\n";
print "②計算ファイル作成<P>\n";
print "<FORM METHOD=\"GET\" ACTION=\"$scrname\">\n";
print "<INPUT type=\"hidden\" value=\"$date{'align'}\" name=\"align\">\n";
print "<INPUT type=\"text\" value=\"$year\" name=\"year\" size=\"6\">/";
print "<INPUT type=\"text\" value=\"$month\" name=\"month\" size=\"4\">から";
print "<INPUT type=\"text\" value=\"3\" name=\"from\" size=\"4\">ヶ月間<P>\n";
print "<INPUT type=\"submit\" value=\"計算\">\n";
print "</FORM>\n</TH>\n";
$scrname=~s/$calcscr/$viewscr/;
print "<TH>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</TH>\n<TH>\n";
print "③当番表表示<P>\n";
print "<FORM METHOD=\"GET\" ACTION=\"$scrname\">\n";
print "<INPUT type=\"hidden\" value=\"$date{'align'}\" name=\"align\">\n";
print "<INPUT type=\"text\" value=\"$year\" name=\"year\" size=\"6\">/";
print "<INPUT type=\"text\" value=\"$month\" name=\"month\" size=\"4\"><P>\n";
print "<INPUT type=\"submit\" value=\"表示\">\n";
print "</FORM>\n";
print "</TH>\n</TR>\n</TABLE>\n";
print "</DIV>\n";
print "</BODY>\n</HTML>\n";
exit 0;

