#!/usr/bin/perl

use strict;
use lib qw(.);
use holiday;

print "Content-type: text/html; charset=UTF-8\n\n";

# Preference Parameter
my $nkfcmd=holiday::nkfcmd;
my $outfile=holiday::infile;
my $diridx=holiday::diridx;
my $inptscr=holiday::inptscr;
my $subscr=holiday::subscr;

# Variable Parameter
my ($dirpath, $pathinf, $scrname);
if(defined $ENV{'PATH_TRANSLATED'}){
	$dirpath=$ENV{'PATH_TRANSLATED'};
	$dirpath=~s/$diridx.*//i;
	$dirpath=~s/\/$//;
}
if(defined $ENV{'PATH_INFO'}){
	$pathinf=$ENV{'PATH_INFO'};
	$pathinf=~s/\/$//;
}
if(defined $ENV{'SCRIPT_NAME'}){
	$scrname=$ENV{'SCRIPT_NAME'};
	$scrname=~s/$subscr/$inptscr/;
	$scrname.=$pathinf;
	$scrname=~s/\/$//;
}
my $filename=$dirpath."/".$outfile;

# Read Data
my ($post, $name, $value, %param);
read (STDIN, $post, $ENV{'CONTENT_LENGTH'});
my @qstr=split('&', $post);
foreach my $iq (@qstr){
	($name, $value)=split('=', $iq);
	$value=~s/%([A-Fa-f0-9][A-Fa-f0-9])/pack('c', hex($1))/ge;
	$value=~s/\r\n/\n/g;
	$param{$name}=$value;
}
my ($lnum, $cnum, $maxrow, $maxcol, $datkey);
foreach my $ix (keys(%param)){
	($lnum, $cnum)=split('-', $ix) if($param{$ix} ne "");
	$maxrow=$lnum if($maxrow<$lnum);
	$maxcol=$cnum if($maxcol<$cnum);
}

# Header Standard Output
print "<HTML>\n<HEAD>\n";
print "<TITLE>Duty Chart Submit Page</TITLE>\n";
print "</HEAD>\n\n<BODY>\n";
print "<DIV ALIGN=$param{'align'}>\n" if(defined $param{'align'});
print "<H2>当番表順位入力結果</H2>\n";
print "<TABLE BORDER=3 CELLPADDING=1 CELLSPACING=1>\n";
print "<TR><TH>順番</TH>";

# Data Output
open FILE, "| $nkfcmd -s -Lw > $filename" or die;
flock FILE, 2;
for($lnum=0; $lnum<=$maxrow; $lnum++){
	for($cnum=1; $cnum<=$maxcol; $cnum++){
		print "<TR align=center><TH>$lnum</TH>" if($cnum==1 && $lnum!=0);
		$datkey=$lnum."-".$cnum;
		if($param{$datkey} ne ""){
			if($lnum==0){ print "<TH>$param{$datkey}</TH>"; }
			else{ print "<TD nowrap>$param{$datkey}</TD>"; }
			print FILE $param{$datkey};
		}
		else{ print "<TH>&nbsp;</TH>"; }
		print FILE "," if($cnum!=$maxcol);
		if($cnum==$maxcol){
			print "</TR>\n";
			print FILE "\n";
		}
	}
}
flock FILE, 8;
close FILE;

# Footer Standard Output
print "</TABLE>\n<P>\n";
print "<FORM METHOD=\"GET\" ACTION=\"$scrname\">\n";
print "<INPUT type=\"hidden\" value=\"$param{'align'}\" name=\"align\">\n" if(defined $param{'align'});
print "<INPUT type=\"submit\" value=\"戻る\">\n";
print "</FORM>\n";
print "</DIV>\n" if(defined $param{'align'});
print "</BODY>\n</HTML>\n";
exit 0;

