#!/usr/bin/perl

use strict;
use lib qw(.);
use holiday;

print "Content-type: text/html; charset=UTF-8\n\n";

# Preference Parameter
my $nkfcmd=holiday::nkfcmd;
my $infile=holiday::orgfile;
my $outfile=holiday::outfile;
my $diridx=holiday::diridx;
my $inptscr=holiday::inptscr;
my $viewscr=holiday::viewscr;

# Variable Parameter
my ($dirpath, $pathinf, $scrname);
if(defined $ENV{'PATH_TRANSLATED'}){
	$dirpath=$ENV{'PATH_TRANSLATED'};
	$dirpath=~s/$diridx.*//i;
	$dirpath=~s/\/$//;
}
if(defined $ENV{'PATH_INFO'}){
	$pathinf=$ENV{'PATH_INFO'};
	$pathinf=~s/\/$//;
}
if(defined $ENV{'SCRIPT_NAME'}){
	$scrname=$ENV{'SCRIPT_NAME'};
	$scrname=~s/$viewscr/$inptscr/;
	$scrname.=$pathinf;
}
my ($name, $value, $holiday, %date);
if($ENV{'QUERY_STRING'} ne ""){
	my @qstr=split('&', $ENV{'QUERY_STRING'});
	foreach my $iq (@qstr){
		($name, $value)=split('=', $iq);
		$date{$name}=$value;
	}
}

# Header Standard Output
print "<HTML>\n<HEAD>\n";
print "<TITLE>$date{'year'}/$date{'month'} Duty Chart Page</TITLE>\n";
print "</HEAD>\n\n<BODY>\n";
print "<DIV ALIGN=$date{'align'}>\n" if(defined $date{'align'});
print "<H2>$date{'year'}年$date{'month'}月度当番表</H2>\n";
print "<TABLE BORDER=3 CELLPADDING=1 CELLSPACING=1>\n";

# Calculation Result View
my ($prtyear, $prtmonth, $prtday, $orgday, $colchk, $colmax, @colstr);
my $ix=0;
open TBL, "$nkfcmd -s -Lu $dirpath/$infile |" or die;
while(my $line=<TBL>){
	chomp($line);
	$colchk=0;
	@colstr=split(',', $line);
	print "<TR>" if($.==1);
	foreach my $col (@colstr){
		$colchk++;
		if($.==1){ print "<TH>$col</TH>"; }
		if($colchk==1){
			($prtyear, $prtmonth, $orgday)=split('-', $col);
			$prtday=sprintf('%2d', $orgday);
			if($prtyear==$date{'year'} && $prtmonth==$date{'month'}){
				print "<TR align=center>";
				$holiday=holiday::whatday($prtyear, $prtmonth, $prtday);
				if($holiday>1){ print "<TH><FONT COLOR=#FF0000>$prtday</FONT></TH>"; }
				elsif($holiday==1){ print "<TH><FONT COLOR=#0000FF>$prtday</FONT></TH>"; }
				else{ print "<TH>$prtday</TH>"; }
			}
		}
		elsif($col ne ""){ print "<TD nowrap>$col</TD>" if($prtyear==$date{'year'} && $prtmonth==$date{'month'}); }
		else{ print "<TD nowrap>&nbsp;</TD>" if($prtyear==$date{'year'} && $prtmonth==$date{'month'}); }
	}
	for($ix=$colchk; $ix<=$colmax; $ix++){
		print "<TD nowrap>&nbsp;</TD>" if($prtyear==$date{'year'} && $prtmonth==$date{'month'});
	}
	if($.==1){ $colmax=$colchk-1; }
	print "</TR>\n" if($.==1 || ($prtyear==$date{'year'} && $prtmonth==$date{'month'}));
}
close TBL;
print "</TABLE>\n";

# Condition Select File Output
my ($num, @outdat);
open INF, "$nkfcmd -s -Lu $dirpath/$infile |" or die;
while(my $line=<INF>){
	chomp($line);
	$num=$.;
	$num--;
	$outdat[$num]=$line;
}
close INF;
$num=0;
open CSV, "> $dirpath/$outfile" or die;
foreach my $line (@outdat){
	$num++;
	if($num==1){
		print CSV "$line\r\n";
	}
	else{
		$colchk=0;
		@colstr=split(',', $line);
		foreach my $col (@colstr){
			$colchk++;
			($prtyear, $prtmonth, $prtday)=split('-', $col) if($colchk==1);
		}
		print CSV "$line\r\n" if($prtyear==$date{'year'} && $prtmonth==$date{'month'});
	}
}
close CSV;

# Footer Standard Output
print "<P>\n";
print "<A HREF=\"$pathinf/$outfile\">CSVファイルのダウンロード</A>\n";
print "</DIV>\n" if(defined $date{'align'});
print "<P>\n";
print "<DIV ALIGN=$date{'align'}>\n" if(defined $date{'align'});
print "<FORM METHOD=\"GET\" ACTION=\"$scrname\">\n";
print "<INPUT type=\"hidden\" value=\"$date{'align'}\" name=\"align\">\n" if(defined $date{'align'});
print "<INPUT type=\"submit\" value=\"戻る\">\n";
print "</FORM>\n";
print "<P>\n";
print "<A HREF=\"$pathinf/$infile\">計算ファイルのダウンロード</A>\n";
print "</DIV>\n" if(defined $date{'align'});
print "</BODY>\n</HTML>\n";
exit 0;

